"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSimpleContext = exports.SimpleContext = void 0;
const crypto_1 = require("crypto");
class SimpleContext {
    constructor(id = (0, crypto_1.randomUUID)()) {
        this.id = id;
        this.properties = {};
        this.forks = [];
        this.contextId = this.id;
    }
    getProperty(key) {
        return this.properties[key];
    }
    setProperty(key, value) {
        this.properties[key] = value;
    }
    fork(id) {
        this.forks = [...this.forks, new SimpleContext(id)];
    }
    setForkProperty(id, key, value) {
        const fork = this.forks.find((fork) => fork.contextId === id);
        if (fork) {
            fork.setProperty(key, value);
        }
    }
    getForkProperty(id, key) {
        const fork = this.forks.find((fork) => fork.contextId === id);
        if (fork) {
            return fork.getProperty(key);
        }
        return undefined;
    }
}
exports.SimpleContext = SimpleContext;
function createSimpleContext() {
    return new SimpleContext();
}
exports.createSimpleContext = createSimpleContext;
